/* =====================================================================

   LiMo - PSX2 Liblary
      lmp_joypad  - ѥåϥޥ͡㡼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

/* -------------------------------------------------------------
 --- History

  Jun.26.2001  ߷ס
  Jul.15.2001  ö߷פʤ
  Jul.25.2001  δ
  Jul.26.2001  奨ȥ󥳥
  Jul.27.2001  1st release

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Preface

  lmp_pad_init        -- ѥå³ν
  lmp_pad_release     -- ѥåɽνλ꥽
  lmp_pad_stat        -- ѥå³Ϥ
  lmp_pad_poll        -- ѥåɾɤ߼(ե졼ॳ)
  lmp_pad_read        -- ѥåϾϤ
  lmp_pad_read_triger -- ѥåϾϤ(ȥꥬ)
  lmp_pad_read_repeat -- ѥåϾϤ(ʰץԡ)
  lmp_pad_act         -- 奨ưλ
  lmp_pad_act_stat    -- 奨ưĴ
  lmp_pad_check_reset -- եȥꥻåȤΥå

-------------------------------------------------------------- */

/* -------------------------------------------------------------
 --- Include
-------------------------------------------------------------- */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <linux/ps2/pad.h>
#include "lmp_joypad.h"


/* -------------------------------------------------------------
 --- Ƽ
-------------------------------------------------------------- */

#define  STATDEV "/dev/ps2padstat"
#define  PADSTAT_SIZE  4

#define  NOCONNECT_TIME  512

#define  LOCAL_DEBUG  0

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

typedef struct _PADWORK padwork;
typedef struct _READSTORE readstore;

/* ------------------------------- */
/* ----- ѥåɤ³    ----- */
/* ------------------------------- */
struct _PADWORK {
  int fd;          /* ǥХեϥɥ */
  int pad;         /* ѥåɤ¸̵ͭȤμ (0=none) */
  int analog_p;    /* ʥƥåȤ뤫 (0/1) */
  int analog_b;    /* ʥܥ󤬻Ȥ뤫 (0/1) */
  int err;         /* 顼̵ɤ߹᤿ (0/1) */
  int err_time;    /* 顼֤θ(̤³Ƚ) */
  int act;         /* 奨̵ͭ (0/1/2) */
  unsigned char actwork[6];  /* 奨μ */
  int mode;        /* ưԤξ */
  int step;        /* Ƽ異󥹥ƥåץ */
  unsigned char act_request[6];    /* 奨ưꥯ */
  int act_time[6];    /* 奨ư֥ */
  int amode[16];   /* ʥ⡼ؤΥ */
  int amode_num;   /* ѥåɤΥ⡼ɤĤ뤫 */
  int work[4];     /* ѥ */
};

/* ------------------------------- */
/* ----- ѥåɤξϤ     -- */
/* ------------------------------- */
struct _READSTORE {
  int  key;                /* ܥ (16bit) */
  int  key_prev;           /* 1ե졼Υܥ */
  int  rep_cnt;            /* ԡȥ󥿡 */
  int  stick_l[2];         /* ʥƥå */
  int  stick_r[2];         /* ʥƥå */
  int  button[12];         /* ʥܥ */
  int  gun_x, gun_y;       /* 󥳥ɸ */
};


/* ----- ˵ưѥåȴξֿ  */
enum {
  PADMODE_NORMAL = 0,
  PADMODE_INIT,
  PADMODE_CHKANA,
  PADMODE_CHKANABTN,
  PADMODE_CHKACT,
} execmode;


/* -------------------------------------------------------------
 --- ؿ
-------------------------------------------------------------- */

void  pad_work_init(int);
void  pad_work_chkana(int);
void  pad_work_chkanabtn(int);
void  pad_work_chkact(int);
void  pad_work_reqact(int);

void  act_control(int);


/* -------------------------------------------------------------
 --- ѿ
-------------------------------------------------------------- */

/* --- ǥХ̾ */
const char  *joyport[] = {
  "/dev/ps2pad00",
  "/dev/ps2pad10"
};

/* ----- ʥꥯ */
static int  store_mode;
static int  store_button_mode;

/* ----- ѥå³ */
static padwork  j_info[PADMAX];

/* ----- ѥåɾݻ */
static padread  input[PADMAX];


/* -----------------------------------------------------------------------
 --- Interface
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  lmp_pad_init        -- ƥν

   return : 
       analog_mode = ʥƥåͭˤ뤫
       analog_b_sw = ʥܥͭˤ뤫
-------------------------------------------------------------- */
void   lmp_pad_init(int analog_mode, int analog_b_sw)
{
  int	i;
  int	fd;

  /* ----- ʥꥯ */
  store_mode = analog_mode;
  store_button_mode = analog_b_sw;

  /* ----- STATδñʽ */
  for(i=0; i<PADMAX; i++) {
    j_info[i].pad = 0;
    j_info[i].fd = 0;
    j_info[i].err_time = 0;
    j_info[i].mode = PADMODE_INIT;
    j_info[i].step = 0;
    j_info[i].act_time[0] = 0;
    j_info[i].act_time[1] = 0;
    j_info[i].act_time[2] = 0;
    j_info[i].act_time[3] = 0;
    j_info[i].act_time[4] = 0;
    j_info[i].act_time[5] = 0;
    j_info[i].actwork[0] = 0xff;
    j_info[i].actwork[1] = 0xff;
    j_info[i].actwork[2] = 0xff;
    j_info[i].actwork[3] = 0xff;
    j_info[i].actwork[4] = 0xff;
    j_info[i].actwork[5] = 0xff;
  }

  /* --------------------------------------------*/
  /* ----- ѥåɥǥХΥץ              */
  for(i=0; i<PADMAX; i++) {
    fd = open(joyport[i], O_RDONLY | O_NONBLOCK);
#if LOCAL_DEBUG
  printf("open pad %d - %d\n", i, fd);
#endif
    if (fd < 0) {
      /* --- ץ󥨥顼 */
      printf(" --- lmp_joypad : can't open device (%s)\n", joyport[i]);
      /* Ȥʤ褦ˤ */
      j_info[i].pad = 0;
      j_info[i].fd = 0;
      j_info[i].mode = PADMODE_NORMAL;
      j_info[i].step = 0;
      continue;
    }
    else {
      j_info[i].fd = fd;
    }
  }

}


/* -------------------------------------------------------------
  lmp_pad_release     -- ѥåɽνλ꥽

   return : 
-------------------------------------------------------------- */
void   lmp_pad_release(void)
{
  int	i;

  /* ----- ǥХΥ */
  for(i=0; i<PADMAX; i++) {
    if (j_info[i].fd > 0) close(j_info[i].fd);
  }
}


/* -------------------------------------------------------------
  lmp_pad_stat        -- ѥå³Ϥ

   return : 
-------------------------------------------------------------- */
void   lmp_pad_stat(int side, padstat *stat)
{
  int  i;

  /* --- ǧ */
  i = side;
  if ((side < 0) || (side >= PADMAX)) {
    i = 0;
  }
  stat->pad = j_info[i].pad;
  stat->analog_p = j_info[i].analog_p;
  stat->analog_b = j_info[i].analog_b;
  stat->act = j_info[i].act;
  stat->actwork[0] = j_info[i].actwork[0];
  stat->actwork[1] = j_info[i].actwork[1];
  stat->actwork[2] = j_info[i].actwork[2];
  stat->actwork[3] = j_info[i].actwork[3];
  stat->actwork[4] = j_info[i].actwork[4];
  stat->actwork[5] = j_info[i].actwork[5];
}


/* -------------------------------------------------------------
  lmp_pad_poll        -- ѥåɾɤ߼(ե졼ॳ)

   return : reserve
-------------------------------------------------------------- */
int    lmp_pad_poll(void)
{
  unsigned char padbuf[PS2PAD_DATASIZE];
  int  i, j, readsize;
  int  work;
  int  pad;

  for(i=0; i<PADMAX; i++) {
    /* ----------------------------------------------- */
    /*  Ω夲ƱΤ꤯                 */
    /* ----------------------------------------------- */
    switch(j_info[i].mode)
      {
      case PADMODE_INIT:
	pad_work_init(i);
	break;
      case PADMODE_CHKANA:
	pad_work_chkana(i);
	break;
      case PADMODE_CHKANABTN:
	pad_work_chkanabtn(i);
	break;
      case PADMODE_CHKACT:
	pad_work_chkact(i);
	break;

      case PADMODE_NORMAL:
      default:
	/* ----- 奨 */
	act_control(i);
	break;
      }

    if (j_info[i].mode != PADMODE_NORMAL) continue;

    /* ----------------------------------------------- */
    /*  ̾ѥåɾɤ߹ʬ                     */
    /* ----------------------------------------------- */
    /* ----- ǥХԲĤǥå */
    if (j_info[i].fd == 0) continue;

    /* ----- ѥåɾ֤Υ */
    ioctl(j_info[i].fd, PS2PAD_IOCGETSTAT, &work);
    /* --- ѥåɤҤäƤʤ */
    if (work == PS2PAD_STAT_NOTCON) {
      j_info[i].pad = 0;
      j_info[i].mode = PADMODE_INIT;
      j_info[i].step = 0;
      j_info[i].err = 1;
      j_info[i].err_time = 0;
      continue;
    }
    /* --- ̤̿Ωǥå */
    if (work != PS2PAD_STAT_READY) continue;
    
    /* ----- Хåե˾ɤ߹ */
    readsize = read(j_info[i].fd, padbuf, PS2PAD_DATASIZE);

#if  LOCAL_DEBUG
    printf("read size : %d\n", readsize);
#endif

    /* ----- ̵³ȥѥåɾü */
    if (readsize == -1) {
      j_info[i].err = 1;
      j_info[i].err_time++;
      if (j_info[i].err_time > NOCONNECT_TIME) {
	j_info[i].pad = 0;
	j_info[i].mode = PADMODE_INIT;
	j_info[i].step = 0;
	j_info[i].err = 1;
	j_info[i].err_time = 0;
      }
      continue;
    }
    else {
      j_info[i].err = 0;
      j_info[i].err_time = 0;
    }

    /* ----- ѥåɤ̤ΤΤ˸򴹤줿 */
    work = (int)((padbuf[1] & 0xf0) >> 4);
    if (j_info[i].pad != work) {
      /* --- ѥåɾ */
      j_info[i].mode = PADMODE_INIT;
      j_info[i].step = 0;
      continue;
    }
    
    /* ----- ʥʬ */
    if ((j_info[i].pad != 7) || (readsize < 9) || (store_button_mode == 0)) {
      for(j=0; j<12; j++) {
	input[i].button[j] = 0;
      }
    }
    else {
      for(j=0; j<12; j++) {
	input[i].button[j] = padbuf[8+j];
      }
    }
    if ((j_info[i].pad != 7) || (readsize < 5) || (store_mode == 0)) {
      input[i].stick_l[0] = 128;
      input[i].stick_l[1] = 128;
      input[i].stick_r[0] = 128;
      input[i].stick_r[1] = 128;
    }
    else {
      input[i].stick_l[0] = padbuf[7];
      input[i].stick_l[1] = padbuf[6];
      input[i].stick_r[0] = padbuf[5];
      input[i].stick_r[1] = padbuf[4];
    }

    /* ----- 󥳥ξ */
    if ((j_info[i].pad == 6) || (readsize < 5)) {
      input[i].gun_x = (int)((padbuf[5] << 8) + padbuf[4]);
      input[i].gun_y = (int)((padbuf[7] << 8) + padbuf[6]);
    }
    
    /* ----- ǥܥʬ */
    pad = (int)((padbuf[2]<<8) | padbuf[3]);
    pad ^= 0xffff;
    input[i].key_prev = input[i].key;
    input[i].key = pad;
    if (pad == 0) {
      input[i].rep_cnt = 0;
    }
    else {
      input[i].rep_cnt++;
    }
    
  }
  
  return(0);
}


/* -------------------------------------------------------------
  lmp_pad_read        -- ѥåϾϤ

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read(int side, padread *data)
{
   int  i;

   data->key = input[side].key;
   data->key_prev = input[side].key_prev;
   data->rep_cnt = input[side].rep_cnt;
   data->stick_l[0] = input[side].stick_l[0];
   data->stick_l[1] = input[side].stick_l[1];
   data->stick_r[0] = input[side].stick_r[0];
   data->stick_r[1] = input[side].stick_r[1];
   for(i=0; i<12; i++) {
      data->button[i] = input[side].button[i];
   }
   data->gun_x = input[side].gun_x;
   data->gun_y = input[side].gun_y;
}


/* -------------------------------------------------------------
  lmp_pad_read_triger -- ѥåϾϤ(ȥꥬ)

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read_triger(int side, padread *data)
{
   lmp_pad_read(side, data);
   data->key = (input[side].key ^ input[side].key_prev) & input[side].key;
}


/* -------------------------------------------------------------
  lmp_pad_read_repeat -- ѥåϾϤ(ʰץԡ)

   return : 
-------------------------------------------------------------- */
void   lmp_pad_read_repeat(int side, padread *data)
{
   if (input[side].rep_cnt < PAD_REPEAT_1) {
      lmp_pad_read_triger(side, data);
   }
   else {
      if ((input[side].rep_cnt % PAD_REPEAT_2) == 0) {
	 lmp_pad_read(side, data);
      }
      else {
	 lmp_pad_read_triger(side, data);
      }
   }
}


/* -------------------------------------------------------------
  lmp_pad_act         -- 奨ưλ

   return : ư(0=奨Բ/1=괰λ)
      side = ѥåɥ
      work = ư奨ӥåȻ
             (0=stop, 1=act a, 2=act b, 3=both)
      length = ưƤ(ե졼=pollƤФ)
-------------------------------------------------------------- */
int    lmp_pad_act(int side, int work, int power, int length)
{
  int  i, b;

   /* --- 奨̵ǥå */
   if ((j_info[side].pad == 0) ||
       (j_info[side].fd == 0) ||
       (j_info[side].act == 0)) return(0);

   /* --- ƥ奨 */
   b = 1;
   for(i=0; i<2; i++) {
     if ((work & b) != 0) {
       j_info[side].act_request[i] = (unsigned char)(power & 255);
       j_info[side].act_time[i] = length;
     }
     else {
       j_info[side].act_request[i] = 0;
       j_info[side].act_time[i] = 1;
     }
     b <<= 1;
   }

   return(1);
}

 
/* -------------------------------------------------------------
  lmp_pad_act_stat    -- 奨ưĴ

   return : ư(奨ư֤κĤ)
-------------------------------------------------------------- */
int    lmp_pad_act_stat(int side)
{
  int  rest_time;
  int  i;

  rest_time = 0;
  for(i=0; i<6; i++) {
    if (j_info[side].act_time[i] > rest_time) {
      rest_time = j_info[side].act_time[i];
    }
  }

  return(rest_time);
}


/* -------------------------------------------------------------
  lmp_pad_check_reset -- եȥꥻåȤΥå

   return : 0=not, 1=ꥻå׵
-------------------------------------------------------------- */
int  lmp_pad_check_reset(void)
{
  padread  input;
  int  result;

  /* ----- ѥåɤ L1,R1,SELECT,START ƱǥꥻåȽ */
  result = 0;
  lmp_pad_read(0, &input);
  if (input.key == 0x090c) result = 1;
  lmp_pad_read(1, &input);
  if (input.key == 0x090c) result = 1;

  return(result);
}



/* -----------------------------------------------------------------------
 --- ؿ
------------------------------------------------------------------------ */

/* -------------------------------------------------------------
  pad_work_init   -- ѥå³Ԥ
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  pad_work_init(int side)
{
  int readsize, work;
  unsigned char padbuf[PS2PAD_DATASIZE];

  /* ----- ǥХԲĤǥå */
  if (j_info[side].fd == 0) {
    j_info[side].mode = PADMODE_NORMAL;
    return;
  }

  /* ----- ǥХưǥ */
  ioctl(j_info[side].fd, PS2PAD_IOCGETSTAT, &work);
  if (work != PS2PAD_STAT_READY) {
    return;
  }

  /* ----- Хåե˾ɤ߹ */
  readsize = read(j_info[side].fd, padbuf, PS2PAD_DATASIZE);
  /* ----- ̵ǥѥå̤³ */
  if (readsize == -1) {
    j_info[side].pad = 0;
    j_info[side].mode = PADMODE_NORMAL;
  }
  else {
    /* --- ѥåȯǤޤ */
    j_info[side].pad = (int)((padbuf[1] & 0xf0) >> 4);
#if LOCAL_DEBUG
    printf("side %d pad %d\n", side, j_info[side].pad);
#endif
    /* --- ϥʥѥåɤΥå˿ʤߤޤ */
    j_info[side].mode = PADMODE_CHKANA;
    j_info[side].step = 0;
  }

}

/* -------------------------------------------------------------
  pad_work_chkana  -- ʥѥåɤΥå
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  pad_work_chkana(int side)
{
  struct ps2pad_modeinfo  getinfo;
  struct ps2pad_mode     setinfo;
  int	mode_num, mode[16];
  int	i, work;

  /* ----- ǥХưǥ */
  ioctl(j_info[side].fd, PS2PAD_IOCGETSTAT, &work);
  if (work != PS2PAD_STAT_READY) {
#if LOCAL_DEBUG
    printf("please wait - 2\n");
#endif
    return;
  }

  /* -----  */
  for(i=0; i<16; i++) {
    mode[i] = 0;
  }

  /* ----- ѥåɤäƤ⡼ɤǤФ */
  getinfo.term = PS2PAD_MODETABLE;
  getinfo.offs = -1;
  ioctl(j_info[side].fd, PS2PAD_IOCMODEINFO, &getinfo);
  mode_num = getinfo.result % 16;

  for(i=0; i<mode_num; i++) {
    getinfo.term = PS2PAD_MODETABLE;
    getinfo.offs = i;
    ioctl(j_info[side].fd, PS2PAD_IOCMODEINFO, &getinfo);
    mode[i] = getinfo.result;
  }

#if  LOCAL_DEBUG
  for(i=0; i<mode_num; i++) {
    printf("pad side : %d   mode : %d\n", side, mode[i]);
  }
#endif

  /* ----- ѥåɤʥ⡼ɤäƤ뤫 */
  for(i=0; i<mode_num; i++) {
    if (mode[i] == 0x07) {
      /* --- ʥ⡼ɤڤؤ */
      setinfo.offs = i;
      setinfo.lock = 3;	/* ڤؤåϥå */
      ioctl(j_info[side].fd, PS2PAD_IOCSETMODE, &setinfo);
      j_info[side].pad = 0x07;
#if  LOCAL_DEBUG
      printf("pad side %d set to analog.\n", side);
#endif
    }
  }

  j_info[side].mode = PADMODE_CHKANABTN;
  j_info[side].step = 0;
 
}

/* -------------------------------------------------------------
  pad_work_chkanabtn  -- ʥܥΥå
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  pad_work_chkanabtn(int side)
{
  int  req, work;

  /* ----- ǥХưǥ */
  ioctl(j_info[side].fd, PS2PAD_IOCGETSTAT, &work);
  if (work != PS2PAD_STAT_READY) {
#if LOCAL_DEBUG
    printf("please wait - 2 side %d\n", side);
#endif
    return;
  }

  /* ----- ƥåץ֥ */
  switch(j_info[side].step)
    {
      /* ---------------------------------------------*/
      /* ----- ʥܥǽ뤫å */
    case 0:
      ioctl(j_info[side].fd, PS2PAD_IOCPRESSMODEINFO, &req);
#if  LOCAL_DEBUG
      printf("pad side %d  analog button %d\n", side, req);
#endif
      if ((req == 1) && (store_button_mode == 1)) {
	j_info[side].step++;
      }
      else {
	/* -- ʥбǤʤΤǽλ */
	j_info[side].analog_b = 0;
	j_info[side].mode = PADMODE_CHKACT;
	j_info[side].step = 0;
      }
      break;
      /* ---------------------------------------------*/
      /* ----- ʥ⡼ɤλ */
    case 1:
      if (store_button_mode == 1) {
	ioctl(j_info[side].fd, PS2PAD_IOCENTERPRESSMODE, &req);
      }
      else {
	ioctl(j_info[side].fd, PS2PAD_IOCEXITPRESSMODE, &req);
      }
      j_info[side].work[0] = 0;
      j_info[side].step++;
      break;
      /* ---------------------------------------------*/
      /* ----- ʥ⡼ؤδλԤ */
    case 2:
      ioctl(j_info[side].fd, PS2PAD_IOCGETREQSTAT, &req);
      if (req == PS2PAD_RSTAT_COMPLETE) {
	j_info[side].step++;
      }
      else if (req == PS2PAD_RSTAT_FAILED) {
	j_info[side].work[0]++;
	if (j_info[side].work[0] < 8) {
	  j_info[side].step = 0;
	}
	else {
	  /* -- 顼¿ˤ궯Υæ */
	  j_info[side].mode = PADMODE_CHKACT;
	  j_info[side].step = 0;
	}
      }
      break;
      /* ---------------------------------------------*/
      /* ----- ʥ⡼ؤδλ */
    case 3:
      if (store_button_mode == 1) {
	j_info[side].analog_b = 1;
      }
      else {
	j_info[side].analog_b = 0;
      }
      /* --  */
      j_info[side].mode = PADMODE_CHKACT;
      j_info[side].step = 0;
      break;
    }
}

/* -------------------------------------------------------------
  pad_work_chkact  -- 奨̵ͭȼΥå
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  pad_work_chkact(int side)
{
  struct ps2pad_actinfo  pinfo;
  struct ps2pad_act  setact;
  int  i, req, work;

  /* ----- ǥХưǥ */
  ioctl(j_info[side].fd, PS2PAD_IOCGETSTAT, &work);
  if (work != PS2PAD_STAT_READY) {
#if LOCAL_DEBUG
    printf("please wait - 3 side %d\n", side);
#endif
    return;
  }

  /* ----- ƥåץ֥ */
  switch(j_info[side].step)
    {
      /* ---------------------------------------------*/
      /* -----奨οȼå */
    case 0:
      /* --- 奨ο */
      pinfo.actno = -1;
      ioctl(j_info[side].fd,  PS2PAD_IOCACTINFO, &pinfo);
      j_info[side].act = pinfo.result;
#if LOCAL_DEBUG
      printf("actuater num : %d\n", pinfo.result);
#endif
      /* - 奨̵ʤ齪λ */
      if (j_info[side].act == 0) {
	j_info[side].mode = PADMODE_NORMAL;
	j_info[side].step = 0;
      }
      /* - ƥ奨ξɤߤ(Digitalk or Analog) */
      for(i=0; i<j_info[side].act; i++) {
	pinfo.actno = i;
	pinfo.term = PS2PAD_ACTSIZE;
	ioctl(j_info[side].fd,  PS2PAD_IOCACTINFO, &pinfo);
	j_info[side].actwork[i] = pinfo.result;
      }
      /* ---  */
      j_info[side].step++;
      break;
      /* ---------------------------------------------*/
      /* -----奨ѥ᡼ν */
    case 1:
      /* --- 奨ѥ᡼ */
      for(i=0; i<6; i++) {
	if (i < j_info[side].act) {
	  setact.data[i] = i;
	}
	else {
	  setact.data[i] = 255;
	}
      }
      setact.len = 6;
      ioctl(j_info[side].fd,  PS2PAD_IOCSETACTALIGN, &setact);
      /* ---  */
      j_info[side].step++;
      break;
      /* ---------------------------------------------*/
      /* -----奨ѥ᡼괰λԤ */
    case 2:
      ioctl(j_info[side].fd, PS2PAD_IOCGETREQSTAT, &req);
      if (req == PS2PAD_RSTAT_COMPLETE) {
	j_info[side].step++;
      }
      else if (req == PS2PAD_RSTAT_FAILED) {
	j_info[side].work[0]++;
	if (j_info[side].work[0] < 8) {
	  j_info[side].step = 0;
	}
	else {
	  /* -- 顼¿ˤ궯Υæ */
	  j_info[side].step++;
	}
      }
      break;
      /* ---------------------------------------------*/
      /* -----奨ѥ᡼괰λ */
    case 3:
      j_info[side].act_time[0] = 0;
      j_info[side].act_time[1] = 0;
      j_info[side].act_time[2] = 0;
      j_info[side].act_time[3] = 0;
      j_info[side].act_time[4] = 0;
      j_info[side].act_time[5] = 0;
      j_info[side].mode = PADMODE_NORMAL;
      j_info[side].step = 0;
#if LOCAL_DEBUG
    printf("init_done. side %d\n", side);
#endif
      break;
    }
}

/* -------------------------------------------------------------
  pad_work_reqact  -- 奨ꥯȻνǧԤ
   return : 
     side=Ĵ٤ѥåɤֹ
-------------------------------------------------------------- */
void  pad_work_reqact(int side)
{
}





/* -------------------------------------------------------------
  act_control   -- 奨Υȥ
                   ֤ߤ
-------------------------------------------------------------- */
void  act_control(int side)
{
   struct ps2pad_act  setactwork;
   int  i, p;
   int  actnum;

   /* --- 奨̵ǥå */
   if ((j_info[side].pad == 0) ||
       (j_info[side].fd == 0) ||
       (j_info[side].act == 0)) return;
   /* --- ѥ᡼ν */
   for(i=0; i<32; i++) {
     setactwork.data[i] = 0;
   }
   /* --- 奨οǡ򥻥å */
   actnum = 0;
   p = j_info[side].act;
   if (p > 6) p = 6;
   for(i=0; i<p; i++) {
     setactwork.data[actnum] = j_info[side].act_request[i];
     /* -- 奨μˤäƤON/OFFΤ */
     if ((j_info[side].actwork[i] == 0) &&
	 (setactwork.data[actnum] > 1)) {
       setactwork.data[actnum] = 1;
     }
     /* -- С */
     if (actnum < 32) actnum++;
   }
   /* --- counter decriment */
   for (i=0; i<6; i++) {
     if (j_info[side].act_time[i] > 0) j_info[side].act_time[i]--;
     else {
       j_info[side].act_request[i] = 0;
       j_info[side].act_time[i] = 0;
     }
   }
   /* --- 奨μ¹ */
   setactwork.len = 6;
   ioctl(j_info[side].fd, PS2PAD_IOCSETACT, &setactwork);
}

