/* =====================================================================

   LiMo - PSX2 Liblary
      lmp_joypad  - ѥåϥޥ͡㡼

                                  Programed by Rero2 (K.Kunikane)

====================================================================== */

#ifndef LMP_JOYPAD

#define LMP_JOYPAD

/* -------------------------------------------------------------
 --- Define
-------------------------------------------------------------- */

#define PADMAX  2

#define PAD_ANALOG_ON   1
#define PAD_ANALOG_OFF  0
#define PAD_ANALOG_BUTTON_ON   1
#define PAD_ANALOG_BUTTON_OFF  0
#define PAD_SIDE_1  0
#define PAD_SIDE_2  1

#define PAD_REPEAT_1  60
#define PAD_REPEAT_2  5

#define PAD_BUTTON_LEFT      0x8000
#define PAD_BUTTON_DOWN      0x4000
#define PAD_BUTTON_RIGHT     0x2000
#define PAD_BUTTON_UP        0x1000
#define PAD_BUTTON_START     0x0800
#define PAD_BUTTON_R3        0x0400
#define PAD_BUTTON_L3        0x0200
#define PAD_BUTTON_SELECT    0x0100
#define PAD_BUTTON_SQUARE    0x0080
#define PAD_BUTTON_CROSS     0x0040
#define PAD_BUTTON_CIRCLE    0x0020
#define PAD_BUTTON_TRIANGLE  0x0010
#define PAD_BUTTON_R1        0x0008
#define PAD_BUTTON_L1        0x0004
#define PAD_BUTTON_R2        0x0002
#define PAD_BUTTON_L2        0x0001
#define PAD_BUTTON_1         0x0020
#define PAD_BUTTON_2         0x0040
#define PAD_BUTTON_3         0x0010
#define PAD_BUTTON_4         0x0080

#define PAD_ANALOG_LEFT      1
#define PAD_ANALOG_DOWN      3
#define PAD_ANALOG_RIGHT     0
#define PAD_ANALOG_UP        2
#define PAD_ANALOG_SQUARE    7
#define PAD_ANALOG_CROSS     6
#define PAD_ANALOG_CIRCLE    5
#define PAD_ANALOG_TRIANGLE  4
#define PAD_ANALOG_R1        9
#define PAD_ANALOG_L1        8
#define PAD_ANALOG_R2        11
#define PAD_ANALOG_L2        10
#define PAD_ANALOG_1         7
#define PAD_ANALOG_2         6
#define PAD_ANALOG_3         5
#define PAD_ANALOG_4         4

#define GUNCON_SHOT          0x0020
#define GUNCON_A             0x0800
#define GUNCON_B             0x0040

/* --- ѥåɤμID */
#define PAD_DEF_DIGITAL      0x04
#define PAD_DEF_ANALOG       0x07
#define PAD_DEF_DUALSHOCK    0x07
#define PAD_DEF_DUALSHOCK2   0x07
#define PAD_DEF_GUNCON       0x06

/* -------------------------------------------------------------
 --- Structure
-------------------------------------------------------------- */

typedef struct _PADSTAT padstat;
typedef struct _PADREAD padread;

/* ------------------------------- */
/* ----- ѥåɤ³    ----- */
/* ------------------------------- */
struct _PADSTAT {
  int pad;         /* ѥåɤ¸̵ͭȤμ (0=none) */
  int analog_p;    /* ʥƥåȤ뤫 (0/1) */
  int analog_b;    /* ʥܥ󤬻Ȥ뤫 (0/1) */
  int act;         /* 奨̵ͭ (0/1/2) */
  unsigned char actwork[6];  /* 奨μ */
};

/* ------------------------------- */
/* ----- ѥåɤξϤ     -- */
/* ------------------------------- */
struct _PADREAD {
  int  key;                /* ܥ (16bit) */
  int  key_prev;           /* 1ե졼Υܥ */
  int  rep_cnt;            /* ԡȥ󥿡 */
  int  stick_l[2];         /* ʥƥå */
  int  stick_r[2];         /* ʥƥå */
  int  button[12];         /* ʥܥ */
  int  gun_x, gun_y;       /* 󥳥ɸ */
};


/* -------------------------------------------------------------
 --- Extern
-------------------------------------------------------------- */
#ifdef __cplusplus
extern              "C"
{
#endif                          /* __cplusplus */

void   lmp_pad_init(int, int);
void   lmp_pad_release(void);
void   lmp_pad_stat(int, padstat *);
int    lmp_pad_poll(void);
void   lmp_pad_read(int, padread *);
void   lmp_pad_read_triger(int, padread *);
void   lmp_pad_read_repeat(int, padread *);
int    lmp_pad_act(int, int, int, int);
int    lmp_pad_act_stat(int);
int    lmp_pad_check_reset(void);


#ifdef __cplusplus
}
#endif                          /* __cplusplus */

#endif

